//
//  MyDocument.m
//  TeX FoG
//
//  Created by Marco Cosson on Thu Aug 22 2002.
//  Copyright (c) 2002 QuasSoft. All rights reserved.
//

#import "MyDocument.h"
#import "TeXFoGcontroller.h"

@implementation MyDocument

- (id)init
{
    //NSLog(@"Initialising document");
    [super init];
    text=[NSMutableData dataWithLength:1];
    [text retain];
    //NSLog(@"Document initialized");
    return self;
}

- (void)dealloc
{
    //[text release];
    [super dealloc];
}

- (void)encodeWithCoder:(NSCoder *)coder
{
    [coder encodeRect:frame];
    [coder encodeObject:text];
    [coder encodeObject:font];
}

- (id)initWithCoder:(NSCoder *)coder
{
    frame = [coder decodeRect];
    text = [[coder decodeObject] retain];
    font = [[coder decodeObject] retain];
    return self;
}

/*
- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}
*/

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
    [super windowControllerDidLoadNib:aController];
    // Add any code here that need to be executed once the windowController has loaded the document's window.
}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
    if([aType isEqualToString:@"TeXFoG"])
    {
        [[self windowControllers] makeObjectsPerformSelector:@selector(synchronizeData)];
        return [NSArchiver archivedDataWithRootObject:self];
    }
    return nil;
}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
    if([aType isEqualToString:@"TeXFoG"])
    {
        MyDocument	*temp;
        
        temp=[NSUnarchiver unarchiveObjectWithData:data];
        if(temp)
        {
            [self setFrame:[temp frame]];
            [self setText:[temp getText]];
            [self setFont:[temp font]];
            return YES;
        }
    }
    return NO;
}

- (void)makeWindowControllers
{
    //NSLog(@"Assigning controller to document");
    TeXFoGcontroller	*ctl=[[TeXFoGcontroller alloc] initWithWindowNibName:@"MyDocument"];
    [ctl autorelease];
    [self addWindowController:ctl];
}

- (NSData *)getText
{
    return [text subdataWithRange:NSMakeRange(0,[text length])];
}

- (void)setText:(NSData *)theText
{
    [text setData:theText];
}

- (NSRect)frame
{
    return frame;
}

- (void)setFrame:(NSRect)theFrame
{
    frame=theFrame;
}

- (BOOL)hasFrame
{
    return (frame.size.height!=0 && frame.size.width!=0);
}

- (NSFont *)font
{
    return font;
}

- (void)setFont:(NSFont *)theFont
{
    font=theFont;
}

@end
